/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86nasm.decoder;

import static ru.ispras.microtesk.model.x86nasm.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.x86nasm.TempVars;
import ru.ispras.microtesk.model.x86nasm.mode.IAM_DI_D8;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderIAM_DI_D8} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderIAM_DI_D8 extends DecoderItem {
  private static DecoderIAM_DI_D8 instance = null;

  public static DecoderIAM_DI_D8 get() {
    if (null == instance) {
      instance = new DecoderIAM_DI_D8();
    }
    return instance;
  }

  private DecoderIAM_DI_D8() {
    super(
        8,
        true,
        null,
        null
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate disp = null;

    disp = readNextImmediate(image, SBYTE);

    return newResult(new IAM_DI_D8(disp));
  }
}
