/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86nasm.decoder;

import static ru.ispras.microtesk.model.x86nasm.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.x86nasm.TempVars;
import ru.ispras.microtesk.model.x86nasm.op.push_r16;
import ru.ispras.microtesk.model.x86nasm.mode.R16;

/**
 * The {@code DecoderPush_r16} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderPush_r16 extends DecoderItem {
  private static DecoderPush_r16 instance = null;

  public static DecoderPush_r16 get() {
    if (null == instance) {
      instance = new DecoderPush_r16();
    }
    return instance;
  }

  private DecoderPush_r16() {
    super(
        7,
        true,
        "1010000",
        "1111000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R16 src = null;

    if (!matchNextOpc(image, BitVector.valueOf("1010", 2, 4))) {
      return null;
    }
    src = (R16) readNextPrimitive(image, DecoderR16.get());
    if (null == src) {
      return null;
    }

    return newResult(new push_r16(src));
  }
}
